// alkanoidView.h : iCalkanoidView Ŭ ̽
//


#pragma once

struct MY_Vertex
{
	float x,y,z;
	DWORD diffuse;
	float tu, tv;
};

#define BLOCK_COUNT 5

#define MY_VERTEX_TYPE		( D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX1 )

class CMySocket;

#include <map>
using std::map;

class CalkanoidView : public CView
{
protected: // serialization ϴ.
	CalkanoidView();
	DECLARE_DYNCREATE(CalkanoidView)

// Ư
public:
	CalkanoidDoc* GetDocument() const;

// ۾
public:

// 
	public:
	virtual void OnDraw(CDC* pDC);  //  並 ׸  ǵǾϴ.
virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

// 
public:
	virtual ~CalkanoidView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

private:
	void OnInitRenderer();
	HRESULT MakeSwapChain( IDirect3DDevice9* pd3dDevice );

	float m_HalfSize;
	D3DXVECTOR2 m_vCenterVector;

	CRect m_ClientRect;
	size_t m_Life, m_LifeDefault;
	float m_barSize, m_barThick, m_barSide, m_barDegree, m_barPos;
	float m_ballSize, m_ballSpeed, m_ballDegree;
	float m_blockSize;
	float m_lifeSize;
	D3DXVECTOR2 m_vBall, m_vBallOld, m_vLife;
	D3DXVECTOR2 m_vBlock[BLOCK_COUNT*BLOCK_COUNT];
	bool m_bBlock[BLOCK_COUNT*BLOCK_COUNT];
	D3DCOLOR m_BGColor, m_BallColor, m_BarColor, m_BlockColor, m_LifeColor, m_FontColor;
	bool m_bBallAttach;
	bool m_bSpaceBar;

	DWORD m_LastUpdateTime, m_StartTime, m_ScoreTime;
	bool m_bLeft, m_bRight, m_bDirectRight;
	bool m_bTitle;

	typedef map<DWORD, CString> RANKDATA_CONTAINER;
	RANKDATA_CONTAINER m_RankData;

	CString m_Name;
	CMySocket* m_pSocket;

public:
	CComPtr< IDirect3DSwapChain9 >	m_pSwapChain;
	LPDIRECT3DTEXTURE9 m_pBarTexture, m_pBallTexture, m_pLifeTexture, m_pBlockTexture;
	ID3DXFont* m_pd3dFont;

	void UpdateGame();
	void UpdateTitle();
	void UpdateInput( DWORD pastTime );
	void UpdateBall( DWORD pastTime );
	void RenderGame( IDirect3DDevice9* pd3dDevice );
	void RenderTitle( IDirect3DDevice9* pd3dDevice );
	void DrawBar( IDirect3DDevice9* pd3dDevice );
	void DrawBall( IDirect3DDevice9* pd3dDevice );
	void DrawLife( IDirect3DDevice9* pd3dDevice );
	void DrawBlock( IDirect3DDevice9* pd3dDevice, const D3DXVECTOR2& vPos );
	void SetWindowSize();
	void InitGame();
	void SetDead();
	void EndGame();
	void ClearGame();
	void CheckIntersectBar();
	void CheckIntersectBlock();
	void InitTitle();
	const bool IntersectLine( D3DXVECTOR2& vOut, const D3DXVECTOR2& v1s, const D3DXVECTOR2& v1e, const D3DXVECTOR2& v2s, const D3DXVECTOR2& v2e );
	void GetRanking();
	void SendScore( CString name, DWORD scoreTime );

	void Receive();
	void CloseSocket();

public:
	static void    CALLBACK OnFrameMoveCB( IDirect3DDevice9* pd3dDevice, double fTime, float fElapsedTime );
	static void    CALLBACK OnFrameRenderCB( IDirect3DDevice9* pd3dDevice, double fTime, float fElapsedTime );
	static HRESULT CALLBACK OnCreateDeviceCB( IDirect3DDevice9* pd3dDevice, const D3DSURFACE_DESC* pBackBufferSurfaceDesc );
	static HRESULT CALLBACK OnResetDeviceCB( IDirect3DDevice9* pd3dDevice, const D3DSURFACE_DESC* pBackBufferSurfaceDesc );
	static void    CALLBACK OnLostDeviceCB();
	static void    CALLBACK OnDestroyDeviceCB();

// ޽  Լ ߽ϴ.
protected:
	DECLARE_MESSAGE_MAP()
public:
	virtual void OnInitialUpdate();
protected:
public:
	afx_msg void OnSize(UINT nType, int cx, int cy);
};

#ifndef _DEBUG  // alkanoidView.cpp  
inline CalkanoidDoc* CalkanoidView::GetDocument() const
   { return reinterpret_cast<CalkanoidDoc*>(m_pDocument); }
#endif

